import java.io.IOException;
import java.net.InetAddress;
import java.nio.ByteBuffer;

import com.sun.grizzly.Context;
import com.sun.grizzly.ProtocolFilter;
import com.sun.grizzly.util.WorkerThread;

public class MessageFilter implements ProtocolFilter{
	private InetAddress local = null;
	
	public MessageFilter(){
		try{
			local = InetAddress.getLocalHost();
		}catch(Exception e){e.printStackTrace();}
	}
	
    public boolean execute(final Context context) throws IOException {
    
    	final WorkerThread workerThread = ((WorkerThread)Thread.currentThread());
        ByteBuffer buffer = workerThread.getByteBuffer();
		buffer.flip();
		
		int limit = buffer.limit();
		byte[] msgBytes = new byte[limit];
		buffer.get(msgBytes, 0, limit);
		
		String message = new String(msgBytes);
		try {
			if (!message.startsWith("SIP/2.0"))
	    		sendMessage(msgBytes, local.getHostAddress(), Constant.uasPort, Constant.serverPort);
			else
				sendMessage(msgBytes, local.getHostAddress(), Constant.uacPort, Constant.serverPort);
			buffer.clear();
		} catch(Exception e){
			e.printStackTrace();
			buffer.clear();
			return true;
		}
		return true;
    }

    public boolean postExecute(Context context) throws IOException {
    	return true;
    }
    
    private void sendMessage(byte[] sipMessage, String peerAddress, int peerPort, int sendPort) throws IOException {
    	ConnectionManager connectionManager = ConnectionManager.getInstance();
    	connectionManager.send(sipMessage, sipMessage.length, peerAddress, peerPort, sendPort);
    }
}
