import java.net.*;

public class UAS implements Runnable {
	private Thread thread = null;
	private DatagramSocket socket = null;
	private DatagramPacket packet = null;
	private InetAddress local = null;
	
	public UAS(){
		try{
			local = InetAddress.getLocalHost();
		}catch(Exception e){e.printStackTrace();}
	}
	
	private String createResponse(){
		StringBuilder buf = new StringBuilder(256);
		buf.append("SIP/2.0 200 OK");
		buf.append("\r\n");
		return buf.toString();
	}
     
     public void run(){
    	 try{
    		 socket = new DatagramSocket(Constant.uasPort);
    		 packet = new DatagramPacket(new byte[512], 512);
    	 }catch(Exception e){
    		 e.printStackTrace();
    		 return;
    	 }

    	 try{
    		 while(true){
    			 socket.receive(packet);
    			 
    			 String response = createResponse();
    			 packet.setData(response.getBytes());
    			 packet.setAddress(local);
    			 packet.setPort(Constant.serverPort);
    			 socket.send(packet);
    			 System.out.println("UAS sent a response");
    		 }
    	 }catch(Exception e){e.printStackTrace();}
     }

     public synchronized void start() {
    	 this.thread = new Thread(this);
    	 thread.setDaemon(true);
    	 thread.setName("UAS");
    	 thread.start();
     }

}
